"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const server_1 = require("./server");
const express_1 = __importDefault(require("express"));
const md_1 = __importDefault(require("./md"));
const fs_1 = require("fs");
const route_1 = require("./route");
var instance = new server_1.cWebRouteModule();
/**
 * 这里负责http的解析，然后传递给对于的处理方法
 * 目前比较简陋，后续需要增加一下处理
 */
exports.WebRouteModule = {
    name: 'WebRouteModule',
    instance: instance,
    /**在模块初始化开始前注册 */
    use(...handlers) {
        if (instance.inited) {
            // console.warn('has b')
            return false;
        }
        else {
            instance.usePools.push(...handlers);
            return true;
        }
    },
    md_parse: md_1.default,
    /**在模块初始化开始前注册 */
    enableStatic: function (root) {
        if (instance.inited) {
            // console.warn('has b')
            return false;
        }
        else {
            instance.usePools.push(express_1.default.static(root));
            return true;
        }
    },
    /**注册代码模块的位置 */
    routePath(routePath) {
        instance._route_path = routePath;
    },
    docPath(mdfilePath) {
        if (fs_1.existsSync(mdfilePath)) {
            instance._docPath = mdfilePath;
        }
    },
    /**
     * 是否开启跨域
     */
    openCross(b_switch = true) {
        instance.openCross = b_switch;
    },
    /**
     * 注册响应函数
     * @param dirname 接口文件地址
     * @param event 接口名字
     * @param paramlist 提前检查的参数 不满足会提前返回失败
     * @param func 处理函数
     */
    registRoute(dirname, event, paramlist, func) {
        route_1.regist(dirname, event, paramlist, func);
    },
    /**
     * 初始化模块
     * @param port
     */
    init(port, limit) {
        return new Promise(function (resolve) {
            instance.init(port, limit, resolve);
        });
    }
};
